from cc_lang.model.datatypes import Datatypes
from cc_lang.model.language_definition_classes import Keywords, FormatCharacters, ExpressionCharacters, Booleans


class LanguageDefinition:
    # interpreter
    keywords = [
        # define keywords
        Keywords.Library.value,
        Keywords.Class.value,
        Keywords.Function.value,
        Keywords.Variable.value,
        Keywords.Use.value,
        Keywords.From.value,
        Keywords.Constructor.value,
        # builtin functions
        Keywords.Output.value,
        Keywords.Input.value,
        Keywords.Length.value,
        Keywords.Range.value,
        Keywords.Exit.value,
        Keywords.ForEach.value,
        # normal keywords
        Keywords.If.value,
        Keywords.ElseIf.value,
        Keywords.Else.value,
        Keywords.Continue.value,
        Keywords.If.value,
        Keywords.Return.value,
        # loops
        Keywords.While.value,
        Keywords.For.value,
        Keywords.Foreach.value,
        # access
        Keywords.Public.value,
        Keywords.Private.value,
        Keywords.Static.value,
        Keywords.This.value,
        Keywords.Type.value
    ]
    datatypes = [
        Datatypes.Empty.value,
        Datatypes.Any.value,
        Datatypes.Number.value,
        Datatypes.String.value,
        Datatypes.Bool.value,
        Datatypes.List.value,
        Datatypes.Dict.value
    ]
    format_chars = [
        FormatCharacters.Left_Brace.value,
        FormatCharacters.Right_Brace.value,
        FormatCharacters.Left_Parenthesis.value,
        FormatCharacters.Right_Parenthesis.value,
        FormatCharacters.Left_Bracket.value,
        FormatCharacters.Right_Bracket.value,
        FormatCharacters.Semicolon.value,
        FormatCharacters.Colon.value,
        FormatCharacters.Comma.value,
        FormatCharacters.Point.value
    ]
    expr_chars = [
        ExpressionCharacters.Plus.value,
        ExpressionCharacters.Minus.value,
        ExpressionCharacters.Asterisk.value,
        ExpressionCharacters.Slash.value,
        ExpressionCharacters.Equal.value,
        ExpressionCharacters.Caret.value
    ]
    bool_expr_chars = ['<', '>', '!', '!=', '==', '>=', '<=', '&&', '||']
    bool_values = [Booleans.Right.value, Booleans.Wrong.value]
